import java.util.Map;
import java.util.HashMap;
import java.util.Set;
import java.util.HashSet;
import java.util.Collection;

public class Zulassungsregister
{
    private Map<Auto,Person> dieZulassungen;

    public Zulassungsregister()
    {
        this.dieZulassungen = new HashMap<Auto,Person>(); 
    }

    
    public void neueZulassung(Auto einAuto, Person einePerson)
    {
        // ersetzt alte Zulassung, wenn einAuto bereits als Key in dieZulassungen
        this.dieZulassungen.put(einAuto,einePerson);
    }
    
    public Person getZulassungsbesitzer(Auto einAuto)
    {
        // gibt null zurueck, wenn einAuto nicht in dieZulassungen vorkommt
        return this.dieZulassungen.get(einAuto);
    }
    
    public void abmelden(Auto einAuto)
    {
        // Es passiert nichts Schlimmes, wenn einAuto in dieZulassungen nicht vorkommt.
        this.dieZulassungen.remove(einAuto);
    }
    
    public Set<Auto> getAlleZugelassenenAutos()
    {
        return this.dieZulassungen.keySet();
    }
    
    public Collection<Person> getAlleZulassungsbesitzer()
    {
        return this.dieZulassungen.values();
    }
    
    public Set<Auto> getAlleAutosZugelassenAufPerson(Person einePerson)
    {
        HashSet<Auto> set = new HashSet<Auto>();
        
        for(Auto a:this.dieZulassungen.keySet())
        {
            // setzt voraus, dass equals in Person ueberschrieben
            if(this.dieZulassungen.get(a).equals(einePerson))
            {
                set.add(a);
            }
        }
        
        return set;
        
    }
}
